﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<TaskGroup> TaskGroups = new ObservableCollection<TaskGroup>();

        public MainWindow()
        {
            InitializeComponent();

            TaskGroup taskgroup1 = new TaskGroup("TaskGroup1",
                        @"/WpfApplication1;component/dog.jpg");
                    taskgroup1.Tasks.Add(new Task("Task1",
                        @"/WpfApplication1;component/dog.jpg"));
                    taskgroup1.Tasks.Add(new Task("Task2",
                        @"/WpfApplication1;component/dog.jpg"));
                    taskgroup1.Tasks.Add(new Task("Task3",
                        @"/WpfApplication1;component/dog.jpg"));
                    taskgroup1.Tasks.Add(new Task("Task4",
                        @"/WpfApplication1;component/dog.jpg"));

                    this.TaskGroups.Add(taskgroup1);

            TaskGroup taskgroup2 = new TaskGroup("TaskGroup2",
                        @"/WpfApplication1;component/cat.jpg");
                    taskgroup2.Tasks.Add(new Task("Task5",
                        @"/WpfApplication1;component/cat.jpg"));
                    taskgroup2.Tasks.Add(new Task("Task6",
                        @"/WpfApplication1;component/cat.jpg"));
                    taskgroup2.Tasks.Add(new Task("Task7",
                        @"/WpfApplication1;component/cat.jpg"));
                    taskgroup2.Tasks.Add(new Task("Task8",
                        @"/WpfApplication1;component/cat.jpg"));

                    this.TaskGroups.Add(taskgroup2);

            // Set the DataContext of the page to the collection of TaskGroups so we can easily bind elements to the data in our XAML.
            ViewModel vm = new ViewModel() { SelectedTask = new Task("", @"") };
            vm.TaskGroups = TaskGroups;
            this.DataContext = vm;
        }  
    }

    public class ViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        private Task selectedTask;

        public Task SelectedTask
        {
            get
            {
                return selectedTask;
            }
            set
            {
                selectedTask = value;
                if (selectedTask != null)
                {
                    Debug.WriteLine(selectedTask.Text);
                }                
                PropChanged("SelectedTask");
            }
        }

        public ObservableCollection<TaskGroup> TaskGroups { get; set; }
    }

    // The TaskGroup class definition.
    public class TaskGroup 
    {
        // Member variable that stores a reference to a collection of TaskGroup objects.
        private ObservableCollection<Task> _tasks;

        public TaskGroup(string title, string image)
        {
            this.Title = title;
            this.Image = image;
        }

        // Properties that return the Title and Image associated with the TaskGroup.
        public string Title { get; set; }
        public string Image { get; set; }


        // Property that returns a collection of Task objects
        public ObservableCollection<Task> Tasks
        {
            get
            {
                // If we haven't yet created the collection of Task objects, create it now.
                if (this._tasks == null)
                    this._tasks = new ObservableCollection<Task>();

                return this._tasks;
            }
        }  
    }

    // The Task class definition.
    public class Task
    {
        public Task(string text, string image)
        {
            this.Text = text;
            this.Image = image;
        }

        // Properties that return the Text and Image associated with the TaskGroup.
        public string Text { get; set; }
        public string Image { get; set; }
    }
}